Subject: bug#3328 closed by Eli Zaretskii <[email-masked]> (Re: bug#3328: set-default-file-modes on Windows Emacs broken)

From: [email-masked] (Emacs bug Tracking System)
Date: Tue, 19 May 2009 19:45:06 +0000

This is an automatic notification regarding your bug report
which was filed against the emacs package:

#3328: set-default-file-modes on Windows Emacs broken

It has been closed by Eli Zaretskii <[email-masked]>.

Their explanation is attached below along with your original report.
If this explanation is unsatisfactory and you have not received a
better one in a separate message then please contact Eli Zaretskii <[email-masked]> by
replying to this email.

-- 
3328: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=3328
Emacs Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#3328: set-default-file-modes on Windows Emacs broken
From: Eli Zaretskii <[email-masked]>
To: Matthew Carter <[email-masked]>, [email-masked]
Date: Tue, 19 May 2009 22:38:46 +0300

> Date: Mon, 18 May 2009 16:39:31 -0400
> From: Matthew Carter <[email-masked]>
> Cc: 
> 
> Run this lisp expression:
>   (set-default-file-modes ?\644)
> e.g., by putting it in your ~/.emacs or by using M-:
> 
> Then, create a new file, "foo.txt".
> Then, in a cygwin bash shell, run "ls -l foo.txt".
> The file SHOULD have these permissions:
>   -rw-r--r--
> But instead, it has these permissions:
>   -rwxrwxrwx

This is not a bug.  Maybe a missing feature (which is not easy to
implement).  Details follow.

First, the way native Windows programs (such as Emacs) implement
Unix-style permission mode bits, and the way Cygwin implements them,
are very different.  Native Windows applications only look at the
first (most significant) 3 mode bits, and ignore the rest.  Thus,
0644, 0664, and 0666 will all give the same effect: create a file that
is readable and writable by the owner.  If you use 0444, you will get
a read-only file.  And that is about all you can meaningfully get in
the native Windows build of Emacs: the MS emulation of `umask' does
not allow to create files that are not readable by the owner, and it
can not set the executable (x) bit.

This all is a consequence of a simple fact that the MS emulation of
`umask' and related features use a single bit in the file's
attributes: the readonly bit.

Cygwin, OTOH, uses Windows NT security features to emulate the Posix
permissions much closer.  It almost completely ignores the readonly
bit, and instead manipulates the Windows ACLs to emulate Posix
permissions, including owner, group, and world permissions.

So you are (a) expecting from NTEmacs more than it currently supports,
and (b) use incompatible tools to assess the effect of operations on
the file permission bits.

Therefore, I'm closing this bug report.

Thanks anyway for your detailed report.

Subject: set-default-file-modes on Windows Emacs broken
From: Matthew Carter <[email-masked]>
To: [email-masked]
Date: Mon, 18 May 2009 16:39:31 -0400

    * The version number of Emacs.

GNU Emacs 22.2.1 (i386-mingw-nt5.1.2600) of 2008-03-26 on RELEASE

    * The operands given to the configure command when Emacs was installed.

I installed this version of Windows emacs as a binary installation downloaded from the web, so I never ran a "configure" command.

    * A complete list of any modifications you have made to the Emacs source. 

None.

    * Details of any other deviations from the standard procedure for installing GNU Emacs.

None.

    * The precise commands we need to type to reproduce the bug.

Run this lisp expression:
  (set-default-file-modes ?\644)
e.g., by putting it in your ~/.emacs or by using M-:

Then, create a new file, "foo.txt".
Then, in a cygwin bash shell, run "ls -l foo.txt".
The file SHOULD have these permissions:
  -rw-r--r--
But instead, it has these permissions:
  -rwxrwxrwx

I tried passing various values to set-default-file-modes to see whether it had any effect at all.  It did, but not the expected effect.  Here are the results I found:

The first column tells the value that I passed in to set-default-file-modes .
The second column tells what value the default-file-modes function returned as a result.
The third column shows the actual permissions that a created file had (as shown by cygwin "ls -l").
(All values are shown in octal.)

      set-default-file-modes     default-file-modes     file permissions
      ----------------------     ------------------     ----------------
        01                       0177                   0555
      0700                       0777                   0755
      0777                       0777                   0755
         0                       0177                   0555
      0400                       0577                   0555
       040                       0177                   0555